Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions | Related
kList Class Reference
kApi/Data

## Description

Represents a doubly-linked list.

The kList class represents a doubly-linked list of objects or values. The kList constructor accepts a kType value that determines the type of items that will be stored in the list. The list will automatically grow as new items are added or inserted.

kStatus ListExample()
{
kList list = kNULL;
k32s values[] = { 1, 2, 3, 5, 7, 9 };
kSize i;
kListItem it = kNULL; //list iterator
kTry
{
//create a list that can store 32-bit integers
kTest(kList_Construct(&list, kTypeOf(k32s), 0, kNULL));
//add some initial items to the list
for (i = 0; i < kCountOf(values); ++i)
{
kTest(kList_Add(list, &values[i], kNULL);
}
//print some information about the list and its items
printf("Item type: %s\n", kType_Name(kList_ItemType(list)));
printf("Count: %u\n", (k32u) kList_Count(list));
it = kList_First(list);
while (!kIsNull(it))
{
//the kList_As_ macro can be used to get a list item and cast it to the desired type;
//this is equivalent to *(k32s*)kList_At(list, it);
k32s value = kList_As_(list, it, k32s);
it = kList_Next(list, it);
}
}
kFinally
{
kObject_Destroy(list);
kEndFinally();
}
return kOK;
}

For lists that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the list is destroyed. To recursively destroy both the list and the list items, use kObject_Dispose.

kList supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kList supports the kdat6 serialization protocol.

Inheritance diagram for kList:

## Public Member Functions
kStatus | kList_Add (kList list, const void *itemContent, kListItem *item)
| Adds a new item to the end of the list. More...
kStatus | kList_Allocate (kList list, kType itemType, kSize initialCapacity)
| Reallocates the list. More...
kStatus | kList_Assign (kList list, kList source)
| Performs a shallow copy of the source list. More...
void * | kList_At (kList list, kListItem item)
| Returns a pointer to the content associated with a list item. More...
void * | kList_AtIndex (kList list, kSize index)
| Returns a pointer to the content associated with a list item at the specified index. More...
kSize | kList_Capacity (kList list)
| Returns the number of elements for which space has been allocated. More...
kStatus | kList_Clear (kList list)
| Sets the count of list items to zero. More...
kStatus | kList_Construct (kList *list, kType itemType, kSize initialCapacity, kAlloc allocator)
| Constructs a kList object. More...
kSize | kList_Count (kList list)
| Returns the count of list elements. More...
kListItem | kList_FindIndex (kList list, kSize index)
| Finds a reference to the list item at the specified index. More...
kListItem | kList_First (kList list)
| Gets a reference to the first list item. More...
kStatus | kList_Insert (kList list, kListItem before, const void *itemContent, kListItem *item)
| Inserts an item into the list before the specified list item. More...
kStatus | kList_Item (kList list, kListItem item, void *content)
| Gets the content associated with a list item. More...
kType | kList_ItemType (kList list)
| Returns the item type. More...
kListItem | kList_Last (kList list)
| Gets a reference to the last list item. More...
kListItem | kList_Next (kList list, kListItem item)
| Given a list item, gets a reference to the next list item. More...
kListItem | kList_Previous (kList list, kListItem item)
| Given a list item, gets a reference to the previous list item. More...
kStatus | kList_Purge (kList list)
| Disposes any elements in the list and sets the count of list items to zero. More...
kStatus | kList_Remove (kList list, kListItem item)
| Removes the specified item from the list. More...
kStatus | kList_Reserve (kList list, kSize capacity)
| Ensures that capacity is reserved for at least the specified number of list items. More...
kStatus | kList_SetItem (kList list, kListItem item, const void *content)
| Sets the content associated with a list item. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets the next collection element and then advances the iterator. More...

## Related
kPointer | kListItem
| Represents a node within a kList object.
#define | kList_ItemType_(LIST) kxList_ItemType_(LIST)
| Macro version of kList_ItemType.
#define | kList_Count_(LIST) kxList_Count_(LIST)
| Macro version of kList_Count.
#define | kList_Capacity_(LIST) kxList_Capacity_(LIST)
| Macro version of kList_Capacity.
#define | kList_First_(LIST) kxList_First_(LIST)
| Macro version of kList_First.
#define | kList_Last_(LIST) kxList_Last_(LIST)
| Macro version of kList_Last.
#define | kList_Next_(LIST, ITEM) kxList_Next_(LIST, ITEM)
| Macro version of kList_Next.
#define | kList_Previous_(LIST, ITEM) kxList_Previous_(LIST, ITEM)
| Macro version of kList_Previous.
#define | kList_At_(LIST, ITEM) kxList_At_(LIST, ITEM)
| Macro version of kList_At.
#define | kList_As_(LIST, ITEM, TYPE) kxList_As_(LIST, ITEM, TYPE)
| Accesses list item content and casts to the specified type. More...
Related inherited from kObject
#define | kObject_Type_(OBJ) kxObject_Type_(OBJ)
| Macro version of kObject_Type.
#define | kObject_Is_(OBJ, TYPE) kxObject_Is_(OBJ, TYPE)
| Macro version of kObject_Is.
#define | kObject_Alloc_(OBJ) kxObject_Allocator_(OBJ)
| Macro version of kObject_Alloc.

The documentation for this class was generated from the following file:

- Data/kList.h